# Summary

* [简介](README.md)
* [序言](preface.md)
* [第一部分：数据系统的基石](part-i.md)
    * [第一章：可靠性、可伸缩性、可维护性](ch1.md)
        * [关于数据系统的思考](ch1.md#关于数据系统的思考)
        * [可靠性](ch1.md#可靠性)
        * [可伸缩性](ch1.md#可伸缩性)
        * [可维护性](ch1.md#可维护性)
        * [本章小结](ch1.md#本章小结)
    * [第二章：数据模型与查询语言](ch2.md)
        * [关系模型与文档模型](ch2.md#关系模型与文档模型)
        * [数据查询语言](ch2.md#数据查询语言)
        * [图数据模型](ch2.md#图数据模型)
        * [本章小结](ch2.md#本章小结)
    * [第三章：存储与检索](ch3.md)
        * [驱动数据库的数据结构](ch3.md#驱动数据库的数据结构)
        * [事务处理还是分析？](ch3.md#事务处理还是分析？)
        * [列式存储](ch3.md#列式存储)
        * [本章小结](ch3.md#本章小结)
    * [第四章：编码与演化](ch4.md)
        * [编码数据的格式](ch4.md#编码数据的格式)
        * [数据流的类型](ch4.md#数据流的类型)
        * [本章小结](ch4.md#本章小结)
* [第二部分：分布式数据](part-ii.md)
    * [第五章：复制](ch5.md)
        * [领导者与追随者](ch5.md#领导者与追随者)
        * [复制延迟问题](ch5.md#复制延迟问题)
        * [多主复制](ch5.md#多主复制)
        * [无主复制](ch5.md#无主复制)
        * [本章小结](ch5.md#本章小结)
    * [第六章：分区](ch6.md)
        * [分区与复制](ch6.md#分区与复制)
        * [键值数据的分区](ch6.md#键值数据的分区)
        * [分区与次级索引](ch6.md#分区与次级索引)
        * [分区再平衡](ch6.md#分区再平衡)
        * [请求路由](ch6.md#请求路由)
        * [本章小结](ch6.md#本章小结)
    * [第七章：事务](ch7.md)
        * [事务的棘手概念](ch7.md#事务的棘手概念)
        * [弱隔离级别](ch7.md#弱隔离级别)
        * [可串行化](ch7.md#可串行化)
        * [本章小结](ch7.md#本章小结)
    * [第八章：分布式系统的麻烦](ch8.md)
        * [故障与部分失效](ch8.md#故障与部分失效)
        * [不可靠的网络](ch8.md#不可靠的网络)
        * [不可靠的时钟](ch8.md#不可靠的时钟)
        * [知识、真相与谎言](ch8.md#知识、真相与谎言)
        * [本章小结](ch8.md#本章小结)
    * [第九章：一致性与共识](ch9.md)
        * [一致性保证](ch9.md#一致性保证)
        * [线性一致性](ch9.md#线性一致性)
        * [顺序保证](ch9.md#顺序保证)
        * [分布式事务与共识](ch9.md#分布式事务与共识)
        * [本章小结](ch9.md#本章小结)
* [第三部分：衍生数据](part-iii.md)
    * [第十章：批处理](ch10.md)
        * [使用Unix工具的批处理](ch10.md#使用Unix工具的批处理)
        * [MapReduce和分布式文件系统](ch10.md#MapReduce和分布式文件系统)
        * [MapReduce之后](ch10.md#MapReduce之后)
        * [本章小结](ch10.md#本章小结)
    * [第十一章：流处理](ch11.md)
        * [传递事件流](ch11.md#传递事件流)
        * [数据库与流](ch11.md#数据库与流)
        * [流处理](ch11.md#流处理)
        * [本章小结](ch11.md#本章小结)
    * [第十二章：数据系统的未来](ch12.md)
        * [数据集成](ch12.md#数据集成)
        * [分拆数据库](ch12.md#分拆数据库)
        * [将事情做正确](ch12.md#将事情做正确)
        * [做正确的事情](ch12.md#做正确的事情)
        * [本章小结](ch12.md#本章小结)
* [术语表](glossary.md)
* [后记](colophon.md)


