# Designing Data-Intensive Applications 

—— **The Big Ideas Behind Reliable, Scalable, and Maintainable Systems**

[Martin Kleppmann](https://martin.kleppmann.com)

> The en-us version only includes **intro**, **summary**, **references** of all chapters to protect the intellectual property of author and publisher.


--------

*Technology is a powerful force in our society. Data, software, and communication can*

*be used for bad: to entrench unfair power structures, to undermine human rights, and to protect vested interests. But they can also be used for good: to make underrepresented people’s voices heard, to create opportunities for everyone, and to avert disasters. This book is dedicated to everyone working toward the good.*

---------

*Computing is pop culture. [...] Pop culture holds a disdain for history. Pop culture is all about identity and feeling like you’re participating. It has nothing to do with cooperation, the past or the future—it’s living in the present. I think the same is true of most people who write code for money. They have no idea where [their culture came from].*

 — [Alan Kay](http://www.drdobbs.com/architecture-and-design/interview-with-alan-kay/240003442), in interview with *Dr Dobb’s Journal* (2012)

---------


## Table of Contents

### [Preface](preface.md)

### [Part I: Foundations of Data Systems](part-i.md)
  - [1. Reliable, Scalable, and Maintainable Applications](ch1.md)
  - [2. Data Models and Query Languages](ch2.md)
  - [3. Storage and Retrieval](ch3.md)
  - [4. Encoding and Evolution](ch4.md)

### [Part II: Distributed Data](part-ii.md)
  - [5. Replication](ch5.md)
  - [6. Partitioning](ch6.md)
  - [7. Transactions](ch7.md)
  - [8. The Trouble with Distributed Systems](ch8.md)
  - [9. Consistency and Consensus](ch9.md)

### [Part III: Derived Data](part-iii.md)
  - [10. Batch Processing](ch10.md)
  - [11. Stream Processing](ch11.md)
  - [12. The Future of Data Systems](ch12.md)

### [Glossary](glossary.md)

### [Colophon](colophon.md)

