# Summary

* [簡介](README.md)
* [序言](preface.md)
* [第一部分：資料系統的基石](part-i.md)
    * [第一章：可靠性、可伸縮性、可維護性](ch1.md)
        * [關於資料系統的思考](ch1.md#關於資料系統的思考)
        * [可靠性](ch1.md#可靠性)
        * [可伸縮性](ch1.md#可伸縮性)
        * [可維護性](ch1.md#可維護性)
        * [本章小結](ch1.md#本章小結)
    * [第二章：資料模型與查詢語言](ch2.md)
        * [關係模型與文件模型](ch2.md#關係模型與文件模型)
        * [資料查詢語言](ch2.md#資料查詢語言)
        * [圖資料模型](ch2.md#圖資料模型)
        * [本章小結](ch2.md#本章小結)
    * [第三章：儲存與檢索](ch3.md)
        * [驅動資料庫的資料結構](ch3.md#驅動資料庫的資料結構)
        * [事務處理還是分析？](ch3.md#事務處理還是分析？)
        * [列式儲存](ch3.md#列式儲存)
        * [本章小結](ch3.md#本章小結)
    * [第四章：編碼與演化](ch4.md)
        * [編碼資料的格式](ch4.md#編碼資料的格式)
        * [資料流的型別](ch4.md#資料流的型別)
        * [本章小結](ch4.md#本章小結)
* [第二部分：分散式資料](part-ii.md)
    * [第五章：複製](ch5.md)
        * [領導者與追隨者](ch5.md#領導者與追隨者)
        * [複製延遲問題](ch5.md#複製延遲問題)
        * [多主複製](ch5.md#多主複製)
        * [無主複製](ch5.md#無主複製)
        * [本章小結](ch5.md#本章小結)
    * [第六章：分割槽](ch6.md)
        * [分割槽與複製](ch6.md#分割槽與複製)
        * [鍵值資料的分割槽](ch6.md#鍵值資料的分割槽)
        * [分割槽與次級索引](ch6.md#分割槽與次級索引)
        * [分割槽再平衡](ch6.md#分割槽再平衡)
        * [請求路由](ch6.md#請求路由)
        * [本章小結](ch6.md#本章小結)
    * [第七章：事務](ch7.md)
        * [事務的棘手概念](ch7.md#事務的棘手概念)
        * [弱隔離級別](ch7.md#弱隔離級別)
        * [可序列化](ch7.md#可序列化)
        * [本章小結](ch7.md#本章小結)
    * [第八章：分散式系統的麻煩](ch8.md)
        * [故障與部分失效](ch8.md#故障與部分失效)
        * [不可靠的網路](ch8.md#不可靠的網路)
        * [不可靠的時鐘](ch8.md#不可靠的時鐘)
        * [知識、真相與謊言](ch8.md#知識、真相與謊言)
        * [本章小結](ch8.md#本章小結)
    * [第九章：一致性與共識](ch9.md)
        * [一致性保證](ch9.md#一致性保證)
        * [線性一致性](ch9.md#線性一致性)
        * [順序保證](ch9.md#順序保證)
        * [分散式事務與共識](ch9.md#分散式事務與共識)
        * [本章小結](ch9.md#本章小結)
* [第三部分：衍生資料](part-iii.md)
    * [第十章：批處理](ch10.md)
        * [使用Unix工具的批處理](ch10.md#使用Unix工具的批處理)
        * [MapReduce和分散式檔案系統](ch10.md#MapReduce和分散式檔案系統)
        * [MapReduce之後](ch10.md#MapReduce之後)
        * [本章小結](ch10.md#本章小結)
    * [第十一章：流處理](ch11.md)
        * [傳遞事件流](ch11.md#傳遞事件流)
        * [資料庫與流](ch11.md#資料庫與流)
        * [流處理](ch11.md#流處理)
        * [本章小結](ch11.md#本章小結)
    * [第十二章：資料系統的未來](ch12.md)
        * [資料整合](ch12.md#資料整合)
        * [分拆資料庫](ch12.md#分拆資料庫)
        * [將事情做正確](ch12.md#將事情做正確)
        * [做正確的事情](ch12.md#做正確的事情)
        * [本章小結](ch12.md#本章小結)
* [術語表](glossary.md)
* [後記](colophon.md)

